﻿namespace HeuristicLab.BenchmarkSuite.ERC {
  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Data;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class ProblemErcOptions : NamedItem {
    public ProblemErcOptions() { }

    [StorableConstructor]
    public ProblemErcOptions(bool deserializing) : base(deserializing) { }

    public ProblemErcOptions(ProblemErcOptions origin, Cloner cloner) : base(origin, cloner) {
      this.IntegerErcRange = cloner.Clone(origin.IntegerErcRange);
      this.FloatErcRange = cloner.Clone(origin.FloatErcRange);
      this.CharERCRange = cloner.Clone(origin.CharERCRange);
      this.StringERCOptions = cloner.Clone(origin.StringERCOptions);
      this.BooleanErcOptions = cloner.Clone(origin.BooleanErcOptions);
    }

    [Storable]
    public double ErcProbability { get; set; }
    [Storable]
    public ErcOptionRange<IntValue> IntegerErcRange { get; set; }
    [Storable]
    public ErcOptionRange<DoubleValue> FloatErcRange { get; set; }
    [Storable]
    public BooleanErcOptions BooleanErcOptions { get; set; }

    /// <summary>
    /// Integer represents ASCII value
    /// </summary>
    [Storable]
    public ErcOptionRange<IntValue> CharERCRange { get; set; }

    [Storable]
    public StringErcOptions StringERCOptions { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new ProblemErcOptions(this, cloner);
    }
  }
}
